<template>
    <Header :page="'Profil'"></Header>
    <main>
        <section v-if="userDatas">
            <section class="content">
                <div class="informations">
                    <h2>Informations</h2>
                    <section class="infoContent">
                        <div class="userData">
                            <p class="margin-bottom-10">{{userName}}</p>
                            <button  @click="openSidebar('username')">Change</button>
                            <p class="margin-bottom-10">{{userEmail}}</p>
                            <button @click="openSidebar('usermail')">Change</button>
                            <button class="password-btn" @click="openSidebar('userpassword')">Change password</button>
                            <p class="font-size-18">Create the {{userDatas.dateCreate[0]}}</p>
                            <p class="margin-bottom-30 font-size-18">At {{userDatas.dateCreate[1]}}</p>
                            <!-- <p class="font-size-18">Last Update the 02/03/2022</p>
                            <p class="font-size-18">At 22h01 (Profil Picture)</p> -->
                        </div>
                        <div class="profilePic">
                            <div class="thePicture">
                                <div class="pp" :style="{ 'backgroundImage': `url(${profilePicture ? `http://localhost:3000/files/${profilePicture}` : `../assets/img/footer-pic.svg`})`}"></div>
                            </div>
                            <button @click="openSidebar('profilepicture')" class="profile-pic-btn">Change your profil Picture</button>
                        </div>
                    </section>
                </div>
                <div class="separator"></div>
                <div class="stats">
                    <h2>Stats</h2>
                    <section class="first-stat">
                        <div>
                            <p>Level</p>
                            <p>{{userDatas.level}}</p>
                        </div>
                        <div>
                            <p>Rank</p>
                            <p>{{userDatas.rankId}}</p>
                        </div>
                        <div>
                            <p>Money</p>
                            <p>{{userDatas.money}}</p>
                        </div>
                    </section>
                    <section class="second-stat">
                        <div>
                            <p>Favorite Game</p>
                            <p>ChillCode (5 played)</p>
                        </div>
                        <div>
                            <p>Games played</p>
                            <p>12</p>
                        </div>
                    </section>
                    <section class="history">
                        <p>History</p>
                        <div v-if="userStats.history.length > 0">
                            <p v-for="game in userStats.history" :key="game">{{game.name}} - <span :class="game.result">{{game.result}}</span> - <span>{{game.time}}</span></p>
                        </div>
                        <p v-else class="if-no-game">You haven't played any game yet.</p>
                        <button v-if="userStats.history.length > 0">See More</button>
                    </section>
                </div>
            </section>
            <Sidebar v-model:visible="visibleRight" class="p-sidebar-md bg-indigo-400 flex align-center justify-content-center" position="right" :showCloseIcon="false">
                <changePassword v-if="sidebarOptions === 'userpassword'"></changePassword>
                <changeUsername v-if="sidebarOptions === 'username'"></changeUsername>
                <changeUserMail v-if="sidebarOptions === 'usermail'"></changeUserMail>
                <changeProfilePicture v-if="sidebarOptions === 'profilepicture'"></changeProfilePicture>
            </Sidebar>
        </section>
    </main>
</template>

<script>
import Header from "../components/Header.vue";
import Sidebar from 'primevue/sidebar';
import changePassword from "../components/sidebarContent/changePassword.vue";
import changeUsername from "../components/sidebarContent/changeUsername.vue";
import changeUserMail from "../components/sidebarContent/changeUserMail.vue";
import changeProfilePicture from "../components/sidebarContent/changeProfilePicture.vue";

export default {
    name: "Profil",
    components: {
        Header,
        Sidebar,
        changePassword,
        changeUsername,
        changeUserMail,
        changeProfilePicture
    },
    data() {
        return {
            userStats: {
                games: '',
                wins: '',
                loses: '',
                history: [{
                    name: 'bruh',
                    result: 'win',
                    time: '12121111111111212'
                    },
                    {
                    name: 'bruh',
                    result: 'win',
                    time: '12121212'
                    },
                    {
                    name: 'bruh',
                    result: 'loose',
                    time: '12121212'
                    }],
            },
            visibleRight: false,
            sidebarOptions: null,
        }
    },
    methods: {
        openSidebar(option) {
            this.sidebarOptions = option;
            this.visibleRight = true;
            console.log(this.sidebarOptions);
        },
        closeSidebar() {
            this.visibleRight = false;
        },
        getPicBlob(pic) {
            console.log(pic);
            fetch(`http://localhost:3000/files/${pic}`)
            .then(res => res.blob())
            .then(pict => {
                document.querySelector(".pp").remove();
                let blobPath = URL.createObjectURL(pict);
                let div = document.createElement("div");
                div.className = "pp";
                div.style.backgroundImage = `url(${blobPath})`;
                document.querySelector(".thePicture").appendChild(div);
                //this.toast("Picture changed successfully", "success");
            })
        },
    },
    computed: {
        profilePicture(){
            return this.$store.state.profilePicture;
        },
        userName () {
            return this.$store.state.username;
        },
        userEmail () {
            return this.$store.state.mail;
        },
        userDatas () {
            return this.$store.state.userData;
        },
    },
    mounted() {
        if(this.profilePicture) {
            this.getPicBlob(this.profilePicture);
        }
        // console.log(this.userDatas);
    },
}
</script>

<style scoped>

    main
    {
        width: 100%;
        min-height: 100vh;
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        flex-direction: column;
        background: rgb(0, 6, 24);
        background-size: cover;
    }

    main > section
    {
        width: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        flex-direction: column;
        padding: 0px;
        margin: 0px;
        margin-top: 90px;
    }

    main section.content
    {
        width: 100%;
        display: flex;
        justify-content:flex-start;
        align-items: center;
        color: #ffffff;
        flex-direction: column;
    }

    main section.content > div:first-child,
    main section.content > div:last-child
    {
        height: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: center;
        flex-direction: column;
    }
    main section.content div h2
    {
        margin: 50px;
        font-size: 50px;
        font-family: 'Oswald-SemiBold';
    }
    
    .separator
    {
        width: 3px;
        height: 80vh;
        background: #ffffff;
        margin: 120px 0;
        display: none;
    }

    main section.content div.informations
    {
        height: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        flex-direction: column;
    }

    .infoContent
    {
        width: 100%;
        height: 100%;
        display: flex;
        justify-content: space-between;
        align-items: center;
        flex-direction: column-reverse;
    }

    .infoContent div.userData
    {
        height: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        flex-direction: column;
    }

    .infoContent div.userData p
    {
        font-size: 25px;
        font-family: 'Oswald';
    }

    .infoContent div.userData button
    {
        width: 100px;
        height: 30px;
        border: 1px solid #ffffff;
        border-radius: 5px;
        background: transparent;
        color: #ffffff;
        font-size: 15px;
        font-family: 'Oswald-SemiBold';
        margin-bottom: 50px;
        transition: 0.3s;
        cursor: pointer;
    }

    .infoContent div.userData button:hover
    {
        background: #ffffff;
        color: #000000;
        transform: scale(1.1);
    }


    .infoContent div.profilePic
    {
        height: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: center;
        flex-direction: column;
    }

    .infoContent div.profilePic button
    {
        width: 100px;
        height: 30px;
        border: 1px solid #ffffff;
        border-radius: 5px;
        background: transparent;
        color: #ffffff;
        font-size: 15px;
        font-family: 'Oswald-SemiBold';
        margin: 20px 0;
        cursor: pointer;
    }

    .margin-bottom-10
    {
        margin-bottom: 10px;
    }

    .margin-bottom-30
    {
        margin-bottom: 30px;
    }

    .font-size-18
    {
        font-size: 18px !important;
    }

    .password-btn
    {
        width: 230px !important;
        height: 45px !important;
        font-size: 25px !important;
        margin-top: 10px !important;
    }

    .profile-pic-btn
    {
        width: 230px !important;
        height: 45px !important;
        font-size: 20px !important;
        margin-top: 30px !important;
        transition: 0.3s;
    }

    .profile-pic-btn:hover
    {
        background: #ffffff !important;
        color: #000000 !important;
        transform: scale(1.1);
    }

    main section.content div.stats
    {
        height: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: center;
        flex-direction: column;
    }

    main section.content div.stats > section
    {
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        margin-bottom: 50px;
        flex-wrap: wrap;
    }

    .first-stat > div
    {
        width: 100px;
        height: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        flex-direction: column;
        gap: 20px;
    }

    .first-stat p:first-child
    {
        font-size: 22px;
        font-family: 'Oswald';
        margin-bottom: 2px;
        color: gold;
    }

    .first-stat p:last-child
    {
        font-size: 25px;
        font-family: 'Oswald-Bold';
        margin-bottom: 5px;
        font-weight: bold;
    }
    .second-stat
    {
        flex-direction: column;
        width: 100%;
    }
    .second-stat > div
    {
        height: 100%;
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        flex-direction: column;
    }
    .second-stat p:first-child
    {
        font-size: 22px;
        font-family: 'Oswald';
        margin-bottom: 2px;
        color: gold;
    }

    .second-stat p:last-child
    {
        font-size: 25px;
        font-family: 'Oswald-Bold';
        margin-bottom: 5px;
        font-weight: bold;
    }

    .history
    {
        flex-direction: column;
        width: 100%;
    }

    .history > p:first-child
    {
        font-size: 22px;
        font-family: 'Oswald';
        margin-bottom: 2px;
        color: gold;
    }

    .if-no-game
    {
        font-size: 25px;
        font-family: 'Oswald-Bold';
        margin-bottom: 5px;
        font-weight: bold;
    }

    .history button
    {
        width: 100px;
        height: 30px;
        border: 1px solid #ffffff;
        border-radius: 5px;
        background: transparent;
        color: #ffffff;
        font-size: 15px;
        font-family: 'Oswald-SemiBold';
        margin: 10px 0 50px 0px;
        transition: 0.3s;
        cursor: pointer;
    }

    .history button:hover
    {
        background: #ffffff;
        color: #000000;
        transform: scale(1.03);
    }

    .history div p
    {
        font-size: 25px;
        font-family: 'Oswald-Bold';
        margin-bottom: 2px;
        text-align: start;
    }

    .history div p span:last-child
    {
        font-family: 'Oswald-Light';
    }

    .loose
    {
        color: #ff0000;
    }

    .win
    {
        color: #00ff00;
    }

    .p-sidebar
    {
        background-color: var(--indigo-400) !important;
    }

    @media screen and (min-width: 992px) {
        .infoContent {
            flex-direction: row;
        }
        main > section
        {
            width: 90%;  
            margin-inline: auto;
        }
        .content {
            display: grid !important;
            grid-template-columns: 1fr 2px 1fr;
            gap: 3rem;
        }
        .separator{
            display: block;
        }
    }

</style>
<style>
    .pp
    {
        width: 250px;
        height: 250px;
        border-radius: 50%;
        border: 1px solid #ffffff;
        background-position: center;
        background-size: cover;
    }
</style>